<?php
/***********************************************************************************
 * The contents of this file are subject to the Extension License Agreement
 * ("Agreement") which can be viewed at
 * https://www.espocrm.com/extension-license-agreement/.
 * By copying, installing downloading, or using this file, You have unconditionally
 * agreed to the terms and conditions of the Agreement, and You may not use this
 * file except in compliance with the Agreement. Under the terms of the Agreement,
 * You shall not license, sublicense, sell, resell, rent, lease, lend, distribute,
 * redistribute, market, publish, commercialize, or otherwise transfer rights or
 * usage to the software or any modified version or derivative work of the software
 * created by or for you.
 *
 * Copyright (C) 2024-2025 Letrium Ltd.
 *
 * License ID: f27e70ce6801a13265271f5669c8bc5c
 ************************************************************************************/

namespace Espo\Modules\Project\Tools\Project\Api;

use Espo\Core\Acl;
use Espo\Core\Api\Action;
use Espo\Core\Api\Request;
use Espo\Core\Api\Response;
use Espo\Core\Api\ResponseComposer;
use Espo\Core\Exceptions\BadRequest;
use Espo\Core\Exceptions\Forbidden;
use Espo\Core\Record\EntityProvider;
use Espo\Modules\Project\Entities\ProjectTask;
use Espo\Modules\Project\Tools\ProjectTask\RecordService;

/**
 * @noinspection PhpUnused
 */
class PostSubTaskReOrder implements Action
{

    public function __construct(
        private RecordService $service,
        private EntityProvider $entityProvider,
        private Acl $acl,
    ) {}

    public function process(Request $request): Response
    {
        $id = $request->getRouteParam('id') ?? new BadRequest();
        $ids = $request->getParsedBody()->ids ?? null;
        $targetId = $request->getParsedBody()->targetId ?? null;
        $isAfter = $request->getParsedBody()->isAfter ?? false;

        if (!is_array($ids)) {
            throw new BadRequest("No ids.");
        }

        if (!is_string($targetId)) {
            throw new BadRequest("No targetId.");
        }

        if (!is_bool($isAfter)) {
            throw new BadRequest("Bad isAfter.");
        }

        foreach ($ids as $it) {
            if (!is_string($it)) {
                throw new BadRequest("Bad ids.");
            }
        }

        $parentTask = $this->entityProvider->getByClass(ProjectTask::class, $id);

        if (!$this->acl->checkEntityEdit($parentTask)) {
            throw new Forbidden("No parent task edit access.");
        }

        $targetTask = $this->entityProvider->getByClass(ProjectTask::class, $targetId);

        $this->service->massSubTaskReOrder($ids, $targetTask, $parentTask, $isAfter);

        return ResponseComposer::json(true);
    }
}
